## icewm 1.8.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
CMAKE_POLICY (SET CMP0053 NEW)
PROJECT(ICEWM CXX C)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})

enable_testing()

set(PROJECT_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})

IF(NOT DEFINED(CMAKE_INSTALL_PREFIX))
set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE STRING "Target file space")
ENDIF()
# iiieh, neeing to add some guards, since having this nested construct
# interacts badly when changing a variable afterwards cmake also insists on
# overwritting that variables later :-( if not protected
IF(NOT DEFINED(DATADIR))
set(DATADIR "${CMAKE_INSTALL_PREFIX}/share" CACHE STRING "Shared data files directory")
ENDIF()
IF(NOT DEFINED(LIBDIR))
	set(LIBDIR "${DATADIR}/icewm" CACHE STRING "Location of icewm meta data")
ENDIF()
IF(NOT DEFINED(DOCDIR))
	set(DOCDIR "${DATADIR}/doc/icewm" CACHE STRING "Location of documentation files")
ENDIF()
IF(NOT DEFINED(LOCDIR))
	set(LOCDIR "${DATADIR}/locale" CACHE STRING "System locale data directory")
ENDIF()
IF(NOT DEFINED(CFGDIR))
	set(CFGDIR "${CMAKE_INSTALL_PREFIX}/etc/icewm" CACHE STRING "Location of system-wide configuration files")
ENDIF()
IF(NOT DEFINED(ICEHELPIDX))
	set(ICEHELPIDX "${DOCDIR}/icewm.html" CACHE STRING "Location of HTML manual entry page")
ENDIF()
IF(NOT DEFINED(BINDIR))
set(BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
ENDIF()

find_package(Git)
find_program(SED_EXECUTABLE sed)

if(Git_FOUND AND IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
	execute_process(COMMAND "${GIT_EXECUTABLE}" "describe" "--tags"
		COMMAND "${SED_EXECUTABLE}" "s,[-_],.,g;s,\\.g.*$,,"
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		OUTPUT_VARIABLE VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	set(PACKAGE "icewm")
else()
	FILE(READ "${CMAKE_SOURCE_DIR}/VERSION" vfilecontents)
	STRING(REGEX REPLACE "\n" ";" vfilecontents "${vfilecontents}")
	foreach (line ${vfilecontents})
		STRING(REGEX REPLACE "=" ";" keyval "${line}")
		list(GET keyval 0 _key)
		IF(NOT DEFINED ${_key})
			list(GET keyval 1 ${_key})
		ENDIF()
	endforeach()
endif()
set(PACKAGE_STRING ${PACKAGE})

add_subdirectory(src)
add_subdirectory(po)
add_subdirectory(lib)
add_subdirectory(doc)
add_subdirectory(man)

install(FILES icewm-set-gnomewm contrib/icewm-menu-xrandr DESTINATION ${BINDIR} PERMISSIONS WORLD_EXECUTE OWNER_EXECUTE GROUP_EXECUTE WORLD_READ OWNER_READ OWNER_WRITE GROUP_READ)

=== man/CMakeLists.txt ===
#
# The destination directory for manpages.
#
if(NOT MANDIR)
    set(MANDIR "${DATADIR}/man")
endif()

macro(Pod2Man name sectionId sectionName)
        string(REGEX REPLACE "\\.man$" ".pod" podName "${name}")
        string(REGEX REPLACE "\\.man$" ".${sectionId}" manName "${name}")
        ADD_CUSTOM_COMMAND(
                OUTPUT ${manName}
                DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${podName}
                COMMAND pod2man ARGS --center="${sectionName}"
                --errors="none"
                --fixed="CW"
                --fixedbold="CB"
                --fixeditalic="CI"
                --fixedbolditalic="CX"
                --nourls
                --release="${PACKAGE} ${VERSION}" --section="${sectionId}"
                ${CMAKE_CURRENT_SOURCE_DIR}/${podName} ${manName}
                )
        INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${manName} DESTINATION "${MANDIR}/man${sectionId}")
        list(APPEND MAN_RESULTS ${manName})
endmacro()

set(icewm_man1_files
	icesh.man
	icewmbg.man
	icewmhint.man
	icewm.man
	icewm-session.man
	icewm-set-gnomewm.man
  )

if(CONFIG_EXTERNAL_SYSTRAY)
    list(APPEND icewm_man1_files icewmtray.man)
endif()

set(extra_man1_files
	icehelp.man
	icesound.man
	icewm-menu-fdo.man
	icewm-menu-xrandr.man
  )

set(icewm_man5_files
	icewm-env.man
	icewm-focus_mode.man
	icewm-keys.man
	icewm-menu.man
	icewm-preferences.man
	icewm-prefoverride.man
	icewm-programs.man
	icewm-shutdown.man
	icewm-startup.man
	icewm-theme.man
	icewm-toolbar.man
	icewm-winoptions.man
  )

foreach(x ${icewm_man1_files} ${extra_man1_files})
        Pod2Man(${x} 1 "User Commands")
endforeach()

foreach(x ${icewm_man5_files})
        Pod2Man(${x} 5 "Standards, Environments and Macros")
endforeach()

ADD_CUSTOM_TARGET(manpages ALL DEPENDS ${MAN_RESULTS})

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

PROJECT(ICEWM CXX)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED on)
# TODO: drop this warning around xmas 2020 and raise cmake_minimum_required instead; Debian Jessie EOLs around 2020-06
if(${CMAKE_VERSION} VERSION_LESS "3.1")
    message(WARNING "!! Ancient cmake version detected, please pass flags for C++11 enabling manually through CXXFLAGS environment variable or override CMAKE_CXX_FLAGS")
endif()

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckTypeSize)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(FindPkgConfig)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckCXXCompilerFlag)

SET(CXXFLAGS_COMMON -pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -DHAVE_CONFIG_H -include "${CMAKE_BINARY_DIR}/config.h")
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

set(icewm_libs "")
# optimize for release if not defined explicitly, can be overriden with CMAKE_BUILD_TYPE "None"
if("${CMAKE_BUILD_TYPE}" STREQUAL "" AND ("" STREQUAL "${CMAKE_CXX_FLAGS}"))
    SET(CMAKE_BUILD_TYPE Release)
endif()

# I don't need -rdynamic, thanks!
SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")

SET(CMAKE_REQUIRED_FLAGS )

CHECK_CXX_COMPILER_FLAG(-fvisibility=hidden CXX_VHI)
if(CXX_VHI)
    list(APPEND CXXFLAGS_COMMON -fvisibility=hidden)
endif()

CHECK_CXX_COMPILER_FLAG(-fvisibility-inlines-hidden CXX_VIHI)
if(CXX_VIHI)
    list(APPEND CXXFLAGS_COMMON -fvisibility-inlines-hidden)
endif()

# teach GCC7+ to interpret our comments
CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough=2 HAS_FALLTHROUGH_OPTION)
if(HAS_FALLTHROUGH_OPTION)
    list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough=2)
else()
    CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough HAS_FALLTHROUGH_OPTION)
    if(HAS_FALLTHROUGH_OPTION)
        list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough)
    endif()
endif()

#CHECK_CXX_COMPILER_FLAG(-Wl,-fuse-ld=gold CXX_LINKER_GOLD)
#if(CXX_LINKER_GOLD)
#    list(APPEND icewm_libs -Wl,-fuse-ld=gold)
#endif()

option(CONFIG_LIBPNG "PNGLIB image loader" off)
option(CONFIG_LIBJPEG "JPEGLIB image loader" off)
option(CONFIG_GDK_PIXBUF_XLIB "GDK-PIXBUF based image loader" on)
option(CONFIG_LIBRSVG "Optional SVG images for GDK-PIXBUF" off)
option(CONFIG_XPM "XPM image loader" on)
option(CONFIG_I18N "Define to enable internationalization" on)
option(CONFIG_XRANDR "Define to enable XRANDR extension" on)
option(CONFIG_SESSION "Define to enable X session management" on)
option(CONFIG_EXTERNAL_TRAY "Define for external systray (deprecated)" off)
option(ENABLE_NLS "Enable Native Language Support" on)
option(ENABLE_LTO "Enable Link Time Optimization" off)
option(ENABLE_LOGEVENTS "Enable logging of X11 events" off)

set(LOGEVENTS ${ENABLE_LOGEVENTS})
SET(CONFIG_DEFAULT_THEME "default/default.theme" CACHE STRING "Name of default theme")
SET(CONFIG_UNICODE_SET "" CACHE STRING "Your iconv unicode set in machine endian encoding (e.g. WCHAR_T, UCS-4-INTERNAL, UCS-4LE, UCS-4BE)")
# turn off when empty, see config.h template for details
IF("" STREQUAL "${CONFIG_UNICODE_SET}")
    SET(CONFIG_UNICODE_SET OFF)
ELSE()
    MESSAGE(STATUS "Configured custom unicode set: ${CONFIG_UNICODE_SET}.")
ENDIF()
SET(XTERMCMD xterm CACHE STRING "Default terminal emulator for X11")

# TODO: find some common helper to handle that variables
if(ENABLE_NLS OR CONFIG_I18N)
    find_library(CONFIG_LIBICONV iconv)
    if(CONFIG_LIBICONV)
        LIST(APPEND nls_LIBS iconv)
    endif()
    INCLUDE(FindIntl)
    if(Intl_FOUND)
        LIST(APPEND nls_LIBS ${Intl_LIBRARIES})
        LIST(APPEND nls_CFLAGS -I${Intl_INCLUDE_DIRS})
    endif()
endif()

if(ENABLE_LTO AND ${CMAKE_HOST_SYSTEM_NAME} MATCHES "Linux")
    list(APPEND CXXFLAGS_COMMON -flto)
    list(APPEND EXTRA_LIBS -flto)
endif()

# the only used ones...
# for x in `cat funclist` ; do grep $x src/* lib/* && echo $x >> exlist ; done
# perl -e 'print "CHECK_FUNCTION_EXISTS($_ HAVE_".uc($_).")\n" for @ARGV' `cat exlist`
# perl -e 'print "#cmakedefine HAVE_".uc($_)."\n" for @ARGV' `cat exlist`
CHECK_FUNCTION_EXISTS(backtrace_symbols_fd HAVE_BACKTRACE_SYMBOLS_FD)
CHECK_FUNCTION_EXISTS(memrchr HAVE_MEMRCHR)
CHECK_FUNCTION_EXISTS(strlcat HAVE_STRLCAT)
CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
CHECK_FUNCTION_EXISTS(sysctl HAVE_SYSCTL)
CHECK_FUNCTION_EXISTS(sysctlbyname HAVE_SYSCTLBYNAME)

# perl -e 'do { s/\.|\//_/g; $_=uc $_;  print "#cmakedefine HAVE_$_\n"} for @ARGV' `cat headersDa`
# perl -e 'do {my $orig=$_; s/\.|\//_/g; $_=uc $_; print "CHECK_INCLUDE_FILE_CXX($orig HAVE_$_)\n"} for @ARGV' `cat headersDa`
CHECK_INCLUDE_FILE_CXX(execinfo.h HAVE_EXECINFO_H)
CHECK_INCLUDE_FILE_CXX(fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILE_CXX(libgen.h HAVE_LIBGEN_H)
CHECK_INCLUDE_FILE_CXX(sched.h HAVE_SCHED_H)
CHECK_INCLUDE_FILE_CXX(strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILE_CXX(sys/ioctl.h HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILE_CXX(sys/param.h HAVE_SYS_PARAM_H)
CHECK_INCLUDE_FILE_CXX(sys/sched.h HAVE_SYS_SCHED_H "-include /usr/include/sched.h")
CHECK_INCLUDE_FILE_CXX(sys/sysctl.h HAVE_SYS_SYSCTL_H "-include /usr/include/sys/types.h")
CHECK_INCLUDE_FILE_CXX(uvm/uvm_param.h HAVE_UVM_UVM_PARAM_H)

CHECK_TYPE_SIZE(char SIZEOF_CHAR)
CHECK_TYPE_SIZE(long SIZEOF_LONG)
CHECK_TYPE_SIZE(int SIZEOF_INT)
CHECK_TYPE_SIZE(short SIZEOF_SHORT)

#########################################################
# fiting flags to options and available system features #
#########################################################

pkg_check_modules(fontconfig fontconfig)
pkg_check_modules(xrender REQUIRED xrender)
pkg_check_modules(xcomposite REQUIRED xcomposite)
pkg_check_modules(xdamage REQUIRED xdamage)
pkg_check_modules(xfixes REQUIRED xfixes)
pkg_check_modules(xext REQUIRED xext)
pkg_check_modules(x11 REQUIRED x11)

CHECK_LIBRARY_EXISTS(X11 XInternAtoms ${x11_LIBDIR} HAVE_XINTERNATOMS)

set(icewm_img_libs ${xrender_LDFLAGS} ${xcomposite_LDFLAGS} ${xdamage_LDFLAGS} ${xfixes_LDFLAGS})

# It would be a good idea to use different names for the image options and do the
# logics here.  For now, this self-adapting code modifies the option variables.

set(HINT_CURSORS
[=[
 Cursor support requires either -DCONFIG_XPM=on or -DCONFIG_IMLIB=on.
]=])

set(HINT_IMG_LOADERS
[=[
 There is a choice to be made between two image loaders.
 Either 'yimage_gdk' must be enabled by -DCONFIG_GDK_PIXBUF_XLIB=on,
 or else 'yximage' must be enabled by -DCONFIG_LIBPNG=on.
 The latter requires -DCONFIG_XPM=on, while -DCONFIG_LIBJPEG=on is recommended.
 The first provides optional support for SVG with -DCONFIG_LIBRSVG=on.
 ]=] ${HINT_CURSORS})

# image configuration error check
if(CONFIG_GDK_PIXBUF_XLIB)
    #ok
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    if (NOT CONFIG_LIBRSVG)
        message(WARNING "CONFIG_LIBRSVG is recommended for SVG image support")
    endif()
elseif(CONFIG_XPM AND CONFIG_LIBPNG)
    #ok
    if (NOT CONFIG_LIBJPEG)
        message(WARNING "LIBJPEG is advisable for backgrounds in icewmbg")
    endif()
    set(CONFIG_LIBRSVG off)
else()
    MESSAGE(FATAL_ERROR ${HINT_IMG_LOADERS})
endif()

# cursor configuration error check
if(CONFIG_XPM)
    #ok
    set(CONFIG_IMLIB off)
elseif(CONFIG_IMLIB)
    #ok
    set(CONFIG_XPM off)
else()
    MESSAGE(FATAL_ERROR ${HINT_CURSORS})
endif()

if(CONFIG_GDK_PIXBUF_XLIB)
    pkg_check_modules(pixbuf gdk-pixbuf-xlib-2.0)
    if(NOT pixbuf_FOUND)
        message(FATAL_ERROR "GDX-PIXBUF image loader selected but its dev files were not found."
${HINT_IMG_LOADERS})
    endif()
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    LIST(APPEND icewm_img_libs ${pixbuf_LDFLAGS})
endif()

# this is a) optional, b) loaded through pixbuf anyway
if (CONFIG_LIBRSVG)
    pkg_check_modules(librsvg librsvg-2.0)
    if(NOT librsvg_FOUND)
        message(WARNING
                "SVG image loader selected but librsvg-2.0 dev files not found."
                "SVG support will be not available.")
        set(CONFIG_LIBRSVG off)
    else()
        LIST(APPEND icewm_img_libs ${librsvg_LDFLAGS})
    endif()
endif()

if(CONFIG_XPM)
    pkg_check_modules(libxpm xpm)
    if(NOT libxpm_FOUND)
        message(FATAL_ERROR
                "XPM image loader selected but libXpm dev files not found."
                ${HINT_IMG_LOADERS})
    endif()
    LIST(APPEND icewm_img_libs ${libxpm_LDFLAGS})
endif()

if(CONFIG_LIBPNG)
    pkg_check_modules(libpng libpng)
    if(NOT libpng_FOUND)
        message(FATAL_ERROR
                "PNG image loader selected but libpng dev files not found."
                ${HINT_IMG_LOADERS})
    endif()
    LIST(APPEND icewm_img_libs ${libpng_LDFLAGS})
endif()

if(CONFIG_LIBJPEG)
    pkg_check_modules(libjpeg libjpeg)
    if(NOT libjpeg_FOUND)
        message(FATAL_ERROR
                "JPEG image loader selected but libjpeg dev files not found."
                "Please install libjpeg-dev (or similar)."
                "Otherwise use -DCONFIG_LIBJPEG=off.")
    endif()
    LIST(APPEND icewm_img_libs ${libjpeg_LDFLAGS})
endif()

if(CONFIG_IMLIB)
    pkg_check_modules(libimlib imlib)
    if(NOT libimlib_FOUND)
        message(FATAL_ERROR "IMLIB selected but libImlib dev files not found."
        ${HINT_CURSORS})
    endif()
    LIST(APPEND icewm_img_libs ${libimlib_LDFLAGS})
endif()

IF(CONFIG_SESSION)
    LIST(APPEND sm_LIBS SM)
    LIST(APPEND sm_LIBS ICE)
ENDIF()

option(CONFIG_SHAPE "Define to enable transparent frame	decoration (titlebar borders), requests X shape extension." on)
# TODO: check the symbol: AC_CHECK_LIB([Xext],[XShapeCombineRectangles],
if(CONFIG_SHAPE AND NOT xext_FOUND)
    message(WARNING "Xext library not found, disabling CONFIG_SHAPE")
    set(CONFIG_SHAPE off)
endif()

if(CONFIG_XRANDR)
    pkg_check_modules(xrandr xrandr)
    IF(NOT xrandr_FOUND)
        message(WARNING "Xrandr library not found, disabling CONFIG_XRANDR")
        set(CONFIG_XRANDR off)
    ENDIF()
endif()

option(CONFIG_COREFONTS "Define to enable X11 core fonts" off)
option(CONFIG_XFREETYPE "Define to enable XFT support" on)
if(CONFIG_XFREETYPE)
    pkg_check_modules(xft xft>=2.0)
    IF(NOT xft_FOUND)
        message(WARNING "xft library (>=2.0) not found, disabling CONFIG_XFREETYPE")
        set(CONFIG_XFREETYPE off)
        set(CONFIG_COREFONTS on)
    ELSE()
        set(CONFIG_XFREETYPE_VALUE 2)
    ENDIF()
else()
    set(CONFIG_COREFONTS on)
endif()

set(ICESOUND "ALSA,AO,OSS,ESound" CACHE STRING "List of supported audio subsystems")
string(TOLOWER ${ICESOUND} ICESOUND)
message(STATUS "Checking audio subsystems from ICESOUND: ${ICESOUND}")

#clear cache
set(ENABLE_ALSA off)
set(ENABLE_AO off)
set(ENABLE_OSS off)
set(audio_libs )
set(audio_flags )
# Triggers some cmake bug, use copy-pasta for now
#macro(_addsnd varname flagname)
#        set("${FLAGNAME}" "${${varname}_FOUND}")
#        if("${${varname}_FOUND}" EQUAL 1)
#                list(APPEND audio_libs "${${varname}_LDFLAGS}" "${${varname}_LIBS}")
#                list(APPEND audio_flags "${${varname}_CFLAGS}")
#        endif()
#endmacro()

pkg_check_modules(sndfile sndfile)
if(sndfile_FOUND)
    if(sndfile_FOUND)
        list(APPEND audio_flags "${sndfile_CFLAGS}")
        list(APPEND audio_libs ${sndfile_LDFLAGS})
        list(APPEND audio_libs ${sndfile_LIBS})
    endif()
    if("${ICESOUND}" MATCHES "alsa")
        pkg_check_modules(alsa alsa)
        set(ENABLE_ALSA "${alsa_FOUND}")
        if(alsa_FOUND)
            list(APPEND audio_flags "${alsa_CFLAGS}")
            list(APPEND audio_libs ${alsa_LDFLAGS})
            list(APPEND audio_libs ${alsa_LIBS})
        endif()
    endif()
    if("${ICESOUND}" MATCHES "ao")
        pkg_check_modules(ao ao)
        set(ENABLE_AO "${ao_FOUND}")
        if(ao_FOUND)
            list(APPEND audio_flags "${ao_CFLAGS}")
            list(APPEND audio_libs ${ao_LDFLAGS})
            list(APPEND audio_libs ${ao_LIBS})
        endif()
    endif()

=== debian/changelog ===
icewm (1.8.2-1.0antix2) unstable; urgency=medium

  * removed the mv icons line in icewm.postinst

 -- anticapitalista <antix@operamail.com>  Sun, 13 Sep 2020 12:51:32 +0300

icewm (1.8.2-1.0antix1) unstable; urgency=medium

  * latest upstream bugfix relese
  * includes Use wmHide or wmShow to hide or show the taskbar fix

 -- anticapitalista <antix@operamail.com>  Fri, 11 Sep 2020 19:58:08 +0300

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for icewm

UPSTREAM_BRANCH=icewm-1-4-BRANCH
ICEWM_COMMON=$(CURDIR)/debian/icewm-common
ICEWM=$(CURDIR)/debian/icewm
ICEWM_LITE=$(CURDIR)/debian/icewm-lite
ICEWM_EXP=$(CURDIR)/debian/icewm-experimental
DOCDIR=/usr/share/doc/icewm-common
BDIR=builddir
ICONS=$(CURDIR)/debian/icons
FDO=$(CURDIR)/debian/fdo
CUSTOM=$(CURDIR)/debian/custom
cmakeargs = -DDOCDIR=$(DOCDIR) -DHTMLDIR=$(DOCDIR)/html -DICEHELPIDX=/usr/share/doc/icewm-common/html/icewm.html -DCFGDIR=/etc/X11/icewm -DCMAKE_INSTALL_PREFIX=/usr -DVERSION=$(ORIGVERSION) -DCMAKE_VERBOSE_MAKEFILE=ON -DICESOUND=AO -DCONFIG_GDK_PIXBUF_XLIB=on -DCONFIG_XPM=on -DCONFIG_LIBPNG=off -DCONFIG_LIBRSVG=on -DXTERMCMD=x-terminal-emulator
#-DEXTRA_LIBS="-lsupc++" 
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
-include /usr/share/quilt/quilt.make

CXXFLAGS += $(CPPFLAGS) -DXTERMCMD=x-terminal-emulator -Wall -Wextra
ifeq (linux,$(DEB_TARGET_ARCH_OS))
	 CXXFLAGS += -DUSE_SIGNALFD
endif

%:
	dh $@ --parallel -Scmake

# DEBVERSION=$(shell dpkg-parsechangelog -SVersion)
# that one also works with wheezy
DEBVERSION := $(shell dpkg-parsechangelog |grep ^Version | sed -e s,Version:.,,)
ORIGVERSION := $(shell echo $(DEBVERSION) | sed -e 's,-[^-]*$$,,' )
ORIGTAG := upstream/$(shell echo $(ORIGVERSION) | sed -e 's,~,,g' )

# dh_auto_build is no help here...
PAROPT=$(shell echo $$DEB_BUILD_OPTIONS | sed -e 's,.*parallel=\([0-9]\).*,-j\1,')

#build_lite:
#	$(MAKE) $(PAROPT) -C $(BDIR)-lite
#
#build_normal:
#	$(MAKE) $(PAROPT) -C $(BDIR)-normal

#config_lite:
#	mkdir -p $(BDIR)-lite
#	# this fails on prefering cmake :-( dh_auto_configure --builddirectory=$(BDIR)-lite -- 
#	cd $(BDIR)-lite && cmake .. -DCMAKE_BUILD_TYPE=None $(cmakeargs) -DLITE=on -DEXEEXT=-lite -DCONFIG_XFREETYPE=off -DCONFIG_COREFONTS=on -DXINERAMA=on -DCONFIG_XRANDR=off -DCONFIG_TASKBAR=off -DCONFIG_FDO_MENUS=off -DSKIP_TRANSLATIONS=on -DICESOUND=off
#
#config_normal:
#	mkdir -p $(BDIR)-normal
#	cd $(BDIR)-normal && cmake .. -DCMAKE_BUILD_TYPE=None $(cmakeargs) -DCONFIG_XRANDR=on -DCONFIG_GUIEVENTS=on

override_dh_auto_configure:
	dh_auto_configure -- $(cmakeargs)

#override_dh_auto_configure:
#	$(MAKE) -f debian/rules -j2 config_normal config_lite

#override_dh_auto_build:
#	dh_auto_build
#	cd debian && for x in -lite -experimental ; do cp -lf icewm.postinst icewm$$x.postinst ; cp -lf icewm.prerm icewm$$x.prerm ; done

#override_dh_auto_install:
#	$(MAKE) -C $(BDIR)-lite install DESTDIR=$(CURDIR)/debian/tmp
#	$(MAKE) -C $(BDIR)-normal install DESTDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install
	cd debian && for x in -lite -experimental ; do cp -lf icewm.postinst icewm$$x.postinst ; cp -lf icewm.prerm icewm$$x.prerm ; done
	# XXX: find out why some settings are not gettint defaults if the file is not present, like WorkspaceNames
	#cp $(ICEWM_COMMON)/usr/share/doc/icewm-common/preferences $(ICEWM_COMMON)/usr/share/icewm/
	# Install Debian custom files
	install -m 644 $(ICONS)/mutt*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	install -m 644 $(ICONS)/mozilla*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	install -m 644 $(ICONS)/icewm*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	-mv $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.xpm  $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.orig.xpm
	install -m 644 $(ICONS)/debian.xpm $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.xpm
	mkdir -p $(ICEWM_COMMON)/usr/bin $(ICEWM_COMMON)/etc/X11/icewm
	install -m 644 $(CUSTOM)/toolbar $(CUSTOM)/menu $(ICEWM_COMMON)/usr/share/icewm
	install -m 644 debian/README.cfg $(ICEWM_COMMON)/usr/share/icewm/README
	install -m 755 debian/netstat.sh $(ICEWM_COMMON)/usr/share/icewm
	# Extra docs
	mkdir -p "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ"
	pandoc $(CURDIR)/debian/FAQ/source/index.md -o "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ/IceWM-FAQ.html"
	pandoc -t asciidoc $(CURDIR)/debian/FAQ/source/index.md -o "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ/IceWM-FAQ.txt"
	cd debian ; for x in icewm icewm-lite icewm-experimental ; do mkdir -p $$x/usr/share/lintian/overrides ; cp $$x.lintian $$x/usr/share/lintian/overrides/$$x ; done	
	sed -e 's,^.link.*fonts.googleapis.*,,' -i "$(ICEWM_COMMON)/usr/share/doc/icewm-common/html/"*.html
	dh_link -A

override_dh_auto_clean:
	rm -rf $(BDIR)-lite $(BDIR)-normal IceWM-FAQ.txt configure.in
	# the variants are just symlinks
	rm -f debian/icewm-*.postinst debian/icewm-*.prerm
	dh_auto_clean

override_dh_installchangelogs:
	dh_installchangelogs -picewm-common CHANGES

override_dh_fixperms:
	dh_fixperms
	chmod a+rx,u+w "$(ICEWM_COMMON)/usr/share/doc/icewm-common/examples/startup"

override_dh_compress:
	dh_compress

cleancruft:
	git clean -fdx -e .cproject -e .project -e .settings
	git checkout HEAD -- README.md configure.ac configure.in ChangeLog

set-orig-snapshot:
	lc=$$(git reflog $(UPSTREAM_BRANCH) | head -n1 | cut -f1 -d" ") && dd=$$(date +\%Y\%m\%d) && ov=$$(dpkg-parsechangelog -S Version) && pfx=$$(echo $$ov | sed -e 's,mod.*,mod,') && echo $$lc $$dd $$ov $$pfx && dch --newversion $$pfx+$$dd+$$lc-1

# builds a snapshot of the upstream branch after some plausibility checks
get-orig-source:
	! test -e ../icewm_$(ORIGVERSION).orig.tar.xz || (echo Target already exists ; exit 1)
	lc=`git reflog $(UPSTREAM_BRANCH) | head -n1 | cut -f1 -d" "` && echo "Expected upstream ref: $$lc (on failure run update-debian-mod target)" && grep -m1 ^commit ChangeLog | grep $$lc
	git tag $(ORIGTAG) $(UPSTREAM_BRANCH)
	git archive $(ORIGTAG) --prefix icewm-$(ORIGVERSION)/ | xz -9 > ../icewm_$(ORIGVERSION).orig.tar.xz
	test -d ../tarballs && ln ../icewm_$(ORIGVERSION).orig.tar.xz ../tarballs || true
	pristine-tar commit ../icewm_$(ORIGVERSION).orig.tar.xz $(UPSTREAM_BRANCH)

update-debian-mod:
	grep debian .git/HEAD
	set -x && git log $$(git log $(UPSTREAM_BRANCH) ChangeLog | head -n1  | cut -c 8- )..$(UPSTREAM_BRANCH) --stat=76 -M -C |fmt -sct -w80 > ChangeLog
	git show $(UPSTREAM_BRANCH):ChangeLog >> ChangeLog
	git commit ChangeLog -m "Updating ChangeLog for a new Debian snapshot"

## icewm 1.8.3

=== debian/changelog ===
icewm (1.8.3-1.0antix1) unstable; urgency=medium

  * Latest upstream release
  * mainly bugfixes

 -- anticapitalista <antix@operamail.com>  Thu, 17 Sep 2020 13:43:53 +0300

## icewm 1.9.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -116,12 +116,7 @@
 # perl -e 'do { s/\.|\//_/g; $_=uc $_;  print "#cmakedefine HAVE_$_\n"} for @ARGV' `cat headersDa`
 # perl -e 'do {my $orig=$_; s/\.|\//_/g; $_=uc $_; print "CHECK_INCLUDE_FILE_CXX($orig HAVE_$_)\n"} for @ARGV' `cat headersDa`
 CHECK_INCLUDE_FILE_CXX(execinfo.h HAVE_EXECINFO_H)
-CHECK_INCLUDE_FILE_CXX(fcntl.h HAVE_FCNTL_H)
-CHECK_INCLUDE_FILE_CXX(libgen.h HAVE_LIBGEN_H)
 CHECK_INCLUDE_FILE_CXX(sched.h HAVE_SCHED_H)
-CHECK_INCLUDE_FILE_CXX(strings.h HAVE_STRINGS_H)
-CHECK_INCLUDE_FILE_CXX(sys/ioctl.h HAVE_SYS_IOCTL_H)
-CHECK_INCLUDE_FILE_CXX(sys/param.h HAVE_SYS_PARAM_H)
 CHECK_INCLUDE_FILE_CXX(sys/sched.h HAVE_SYS_SCHED_H "-include /usr/include/sched.h")
 CHECK_INCLUDE_FILE_CXX(sys/sysctl.h HAVE_SYS_SYSCTL_H "-include /usr/include/sys/types.h")
 CHECK_INCLUDE_FILE_CXX(uvm/uvm_param.h HAVE_UVM_UVM_PARAM_H)
@@ -336,3 +331,10 @@
             list(APPEND audio_libs ${ao_LIBS})
         endif()
     endif()
+    if("${ICESOUND}" MATCHES "oss")
+        CHECK_INCLUDE_FILE_CXX(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
+        set(ENABLE_OSS "${HAVE_SYS_SOUNDCARD_H}")
+    endif()
+endif(sndfile_FOUND)
+
+option(XINERAMA "Define to enable Xinerama support" on)

=== debian/changelog ===
icewm (1.9.0-1.0antix1) unstable; urgency=medium

  * latest uptream rlease
  * antiX buster build

 -- anticapitalista <antix@operamail.com>  Fri, 30 Oct 2020 18:01:55 +0200

## icewm 1.9.1

=== debian/changelog ===
icewm (1.9.1-1.0antix2) unstable; urgency=medium

  * Use just one set of XSizeHints for issue ice-wm/icewm#28

 -- anticapitalista <antix@operamail.com>  Mon, 09 Nov 2020 15:17:44 +0200

icewm (1.9.1-1.0antix1) unstable; urgency=medium

  * latest upstream bugfix release
  * antiX buster build

 -- anticapitalista <antix@operamail.com>  Thu, 05 Nov 2020 14:04:53 +0200

## icewm 1.9.2

=== debian/changelog ===
icewm (1.9.2-1.0antix1) unstable; urgency=medium

  * Official upstream release
  * antiX builds

 -- anticapitalista <antix@operamail.com>  Tue, 10 Nov 2020 13:02:58 +0200

## icewm 2.0.0

=== debian/changelog ===
icewm (2.0.0-3.0antix1) unstable; urgency=medium

  * bump release because of Debian sid build issues 

 -- anticapitalista <antix@operamail.com>  Tue, 15 Dec 2020 01:31:52 +0200

icewm (2.0.0-1.0antix1) unstable; urgency=medium

  * latest upstream stable release
  * anti builds

 -- anticapitalista <antix@operamail.com>  Mon, 14 Dec 2020 14:34:19 +0200

## icewm 2.0.1

=== debian/changelog ===
icewm (2.0.1-1.0antix1) unstable; urgency=medium

  * upstream bugfixes
  * antiX build

 -- anticapitalista <antix@operamail.com>  Sun, 03 Jan 2021 13:54:00 +0200

## icewm 2.1.1

=== debian/changelog ===
icewm (2.1.1-1.0antix2) unstable; urgency=medium

  * Create a Settings submenu to reduce Start menu items for issue #543

 -- anticapitalista <antix@operamail.com>  Tue, 26 Jan 2021 19:03:44 +0200

icewm (2.1.1-1.0antix1) unstable; urgency=medium

  * upstream bugfixes
  * antiX build

 -- anticapitalista <antix@operamail.com>  Sun, 24 Jan 2021 16:52:58 +0200

icewm (2.1.0-1.0antix1) unstable; urgency=medium

  * upstream bugfixes
  * antiX build 

 -- anticapitalista <antix@operamail.com>  Sat, 23 Jan 2021 11:37:07 +0200

## icewm 2.1.2

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT(ICEWM CXX)

#
# The list of AsciiDoc pages which need to be converted to HTML.
#
set(ADOC_NAMES icewm.adoc)

#
# The destination directory for HTML pages.
#
if(NOT HTMLDIR)
    if(ICEHELPIDX)
        get_filename_component(HTMLDIR "${ICEHELPIDX}" PATH)
    else()
        set(HTMLDIR "${DOCDIR}")
    endif()
endif()

#
# Detect AsciiDoc convertor to HTML.
#
if(NOT ASCIIDOC)
    find_program(ASCIIDOC NAMES asciidoctor asciidoc)
endif()
if((ASCIIDOC) AND (NOT ASCIIDOC_BACKEND))
    if(ASCIIDOC MATCHES asciidoctor$)
        set(ASCIIDOC_BACKEND "--backend=html5")
    elseif(ASCIIDOC MATCHES asciidoc$)
        set(ASCIIDOC_BACKEND "--backend=html4")
    endif()
endif()

#
# Convert AsciiDoc pages to HTML.
#
if((ASCIIDOC) AND (ASCIIDOC_BACKEND))
    set(HTML_OUTPUT_FILES)
    foreach(adoc ${ADOC_NAMES})
        string(REGEX REPLACE "\\.adoc$" ".html" htm "${adoc}")
        set(txt "${CMAKE_SOURCE_DIR}/doc/${adoc}")
        set(out "${CMAKE_BINARY_DIR}/${htm}")
        ADD_CUSTOM_COMMAND(OUTPUT "${out}"
            COMMAND "${ASCIIDOC}" "${ASCIIDOC_BACKEND}" -o "${out}" "${txt}"
            DEPENDS "${txt}"
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )
        list(APPEND HTML_OUTPUT_FILES "${out}")
    endforeach()
    ADD_CUSTOM_TARGET(build_html_docs ALL DEPENDS ${HTML_OUTPUT_FILES})
else()
    message(WARNING "asciidoctor or its backend not found.\n"
            "NOT regenerating HTML documentation.\n"
            "To rebuild install asciidoctor or asciidoc.")
    FILE(GLOB HTML_OUTPUT_FILES *.html)
endif()

#
# Install HTML pages.
#
foreach(html ${HTML_OUTPUT_FILES})
    install(FILES "${html}" DESTINATION "${HTMLDIR}")
endforeach()
message(STATUS "HTMLDIR => ${HTMLDIR}")

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT(ICEWM CXX)

#
# Which themes to install in alphabetical order
#
set(themesList CrystalBlue Helix Infadel2 NanoBlue
    default icedesert metal2 motif win95)

foreach(_src keys menu programs toolbar winoptions IceWM.jpg)
    set(_pre "${CMAKE_CURRENT_SOURCE_DIR}/${_src}.in")
    if(EXISTS "${_pre}")
        CONFIGURE_FILE("${_pre}" "${CMAKE_CURRENT_BINARY_DIR}/${_src}")
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${_src}"
                DESTINATION "${LIBDIR}")
    else()
        install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/${_src}"
                DESTINATION "${LIBDIR}")
    endif()
endforeach()

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/icewm.desktop" DESTINATION "${DATADIR}/xsessions/")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/icewm-session.desktop" DESTINATION "${DATADIR}/xsessions/")

install(DIRECTORY mailbox taskbar icons ledclock
        DESTINATION "${LIBDIR}"
        FILES_MATCHING PATTERN "*"
        PATTERN "*.in" EXCLUDE)

foreach(theme ${themesList})
    install(DIRECTORY "themes/${theme}"
            DESTINATION "${LIBDIR}/themes")
endforeach()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -60,10 +60,11 @@
 #    list(APPEND icewm_libs -Wl,-fuse-ld=gold)
 #endif()
 
+option(CONFIG_IMLIB2 "Imlib2 image loader" on)
 option(CONFIG_LIBPNG "PNGLIB image loader" off)
 option(CONFIG_LIBJPEG "JPEGLIB image loader" off)
-option(CONFIG_GDK_PIXBUF_XLIB "GDK-PIXBUF based image loader" on)
-option(CONFIG_LIBRSVG "Optional SVG images for GDK-PIXBUF" off)
+option(CONFIG_GDK_PIXBUF_XLIB "GDK-PIXBUF image loader" off)
+option(CONFIG_LIBRSVG "Support SVG format icons" off)
 option(CONFIG_XPM "XPM image loader" on)
 option(CONFIG_I18N "Define to enable internationalization" on)
 option(CONFIG_XRANDR "Define to enable XRANDR extension" on)
@@ -147,23 +148,27 @@
 
 set(HINT_CURSORS
 [=[
- Cursor support requires either -DCONFIG_XPM=on or -DCONFIG_IMLIB=on.
+ Cursor support requires either -DCONFIG_XPM=on or -DCONFIG_IMLIB2=on.
 ]=])
 
 set(HINT_IMG_LOADERS
 [=[
  There is a choice to be made between two image loaders.
  Either 'yimage_gdk' must be enabled by -DCONFIG_GDK_PIXBUF_XLIB=on,
+ or 'imlib2' must be enabled by -DCONFIG_IMLIB2=on,
  or else 'yximage' must be enabled by -DCONFIG_LIBPNG=on.
  The latter requires -DCONFIG_XPM=on, while -DCONFIG_LIBJPEG=on is recommended.
- The first provides optional support for SVG with -DCONFIG_LIBRSVG=on.
+ Support SVG format for Imlib2 or GdkPixbuf with -DCONFIG_LIBRSVG=on.
  ]=] ${HINT_CURSORS})
 
 # image configuration error check
-if(CONFIG_GDK_PIXBUF_XLIB)
-    #ok
-    set(CONFIG_LIBPNG off)
-    set(CONFIG_LIBJPEG off)
+if(CONFIG_IMLIB2)
+    #ok
+    if (NOT CONFIG_LIBRSVG)
+        message(WARNING "CONFIG_LIBRSVG is recommended for SVG image support")
+    endif()
+elseif(CONFIG_GDK_PIXBUF_XLIB)
+    #ok
     if (NOT CONFIG_LIBRSVG)
         message(WARNING "CONFIG_LIBRSVG is recommended for SVG image support")
     endif()
@@ -177,15 +182,16 @@
     MESSAGE(FATAL_ERROR ${HINT_IMG_LOADERS})
 endif()
 
-# cursor configuration error check
-if(CONFIG_XPM)
-    #ok
-    set(CONFIG_IMLIB off)
-elseif(CONFIG_IMLIB)
-    #ok
-    set(CONFIG_XPM off)
-else()
-    MESSAGE(FATAL_ERROR ${HINT_CURSORS})
+if(CONFIG_IMLIB2)
+    pkg_check_modules(libimlib2 imlib2)
+    if(NOT libimlib2_FOUND)
+        message(FATAL_ERROR "IMLIB2 selected but Imlib2 dev files not found."
+                ${HINT_IMG_LOADERS})
+    endif()
+    set(CONFIG_GDK_PIXBUF_XLIB off)
+    set(CONFIG_LIBPNG off)
+    set(CONFIG_LIBJPEG off)
+    LIST(APPEND icewm_img_libs ${libimlib2_LDFLAGS})
 endif()
 
 if(CONFIG_GDK_PIXBUF_XLIB)
@@ -205,11 +211,20 @@
     if(NOT librsvg_FOUND)
         message(WARNING
                 "SVG image loader selected but librsvg-2.0 dev files not found."
-                "SVG support will be not available.")
+                "SVG support will not be available.")
         set(CONFIG_LIBRSVG off)
     else()
         LIST(APPEND icewm_img_libs ${librsvg_LDFLAGS})
     endif()
+endif()
+
+# cursor configuration error check
+if(CONFIG_XPM)
+    #ok
+elseif(CONFIG_IMLIB2)
+    #ok
+else()
+    MESSAGE(FATAL_ERROR ${HINT_CURSORS})
 endif()
 
 if(CONFIG_XPM)
@@ -241,15 +256,6 @@
                 "Otherwise use -DCONFIG_LIBJPEG=off.")
     endif()
     LIST(APPEND icewm_img_libs ${libjpeg_LDFLAGS})
-endif()
-
-if(CONFIG_IMLIB)
-    pkg_check_modules(libimlib imlib)
-    if(NOT libimlib_FOUND)
-        message(FATAL_ERROR "IMLIB selected but libImlib dev files not found."
-        ${HINT_CURSORS})
-    endif()
-    LIST(APPEND icewm_img_libs ${libimlib_LDFLAGS})
 endif()
 
 IF(CONFIG_SESSION)
@@ -331,10 +337,3 @@
             list(APPEND audio_libs ${ao_LIBS})
         endif()
     endif()
-    if("${ICESOUND}" MATCHES "oss")
-        CHECK_INCLUDE_FILE_CXX(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
-        set(ENABLE_OSS "${HAVE_SYS_SOUNDCARD_H}")
-    endif()
-endif(sndfile_FOUND)
-
-option(XINERAMA "Define to enable Xinerama support" on)

=== debian/changelog ===
icewm (2.1.2-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 24 Feb 2021 20:05:50 -0800

icewm (2.1.2-1) unstable; urgency=medium

  * New upstream release
    + fixes descovery of desktop files in folders with broken symlinks

 -- Eduard Bloch <blade@debian.org>  Tue, 09 Feb 2021 22:27:54 +0100

icewm (2.1.1-1) unstable; urgency=medium

  * New upstream release
    + fixes a pseudo crash caused by incorrect internal image handling which
      was accidentally covered by direct use of (now dropped) libxpm
      functionality (closes: #980837)

 -- Eduard Bloch <blade@debian.org>  Mon, 25 Jan 2021 21:08:55 +0100

icewm (2.0.0-2) unstable; urgency=low

  * Disable direct loaders except for Imlib2 and librsvg
  * Dropped libgdx-pixbuf-2.0 dependency (its xlib support is deprecated)

 -- Eduard Bloch <blade@debian.org>  Mon, 14 Dec 2020 16:30:03 +0100

icewm (2.0.0-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Mon, 14 Dec 2020 11:22:49 +0100

icewm (1.9.2-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Thu, 12 Nov 2020 19:25:03 +0100

icewm (1.9.0-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Fri, 30 Oct 2020 22:02:45 +0100

icewm (1.8.3-2) unstable; urgency=low

  * Upload to Unstable
  * Disabling upstream tests (not ready for buildd environment)

 -- Eduard Bloch <blade@debian.org>  Sun, 20 Sep 2020 00:51:30 +0200

icewm (1.8.3-1) experimental; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sat, 19 Sep 2020 10:59:51 +0200

icewm (1.8.1+git20200906-1) experimental; urgency=low

  * New upstream release (plus a few fixes from HEAD)

 -- Eduard Bloch <blade@debian.org>  Sun, 06 Sep 2020 12:11:15 +0200

=== debian/control ===
Source: icewm
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: asciidoctor,
               cmake,
               debhelper (>= 9),
               dpkg-dev (>= 1.16.1~),
               gettext,
               libao-dev,
               libfribidi-dev,
               libglib2.0-dev,
               libimlib2-dev,
               librsvg2-dev,
               libsm-dev,
               libsndfile1-dev,
               libx11-dev,
               libxcomposite-dev,
               libxdamage-dev,
               libxext-dev,
               libxft-dev (>> 2.1.1) | libxft2-dev,
               libxinerama-dev,
               libxrandr-dev,
               libxrender-dev,
               pandoc,
               x11proto-core-dev | x-dev
Build-Conflicts: libesd0-dev, libttf-dev
Standards-Version: 4.5.0
Vcs-Git: https://github.com/Code7R/icewm.git

Package: icewm-common
Architecture: any
Conflicts: menu (<< 2.1.9-1)
Replaces: icewm (<< 1.2.14),
          icewm-gnome-support (<< 1.3.8-3),
          icewm-themes (<< 1.3.8-3)
Depends: sensible-utils, ${misc:Depends}, ${shlibs:Depends}
Recommends: menu, xscreensaver, xterm
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. Can emulate the look of
 Windows'95, OS/2 Warp 3,4, Motif. Tries to take the best features of the above
 systems.
 Features multiple workspaces, opaque move/resize, task bar, window list,
 mailbox status, digital clock. Fast and small.
 .
 This package provides the common files for icewm, icewm-experimental and
 icewm-lite binary packages.

Package: icewm
Architecture: any
Depends: fonts-dejavu-core | ttf-dejavu-core | custom-icewm-font,
         icewm-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: icewm-common (<< 1.3.8-3)
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, and a digital clock.

Package: icewm-lite
Architecture: any
Depends: icewm (= ${binary:Version}),
         icewm-common (= ${binary:Version}),
         ${misc:Depends}
Section: oldlibs
Description: transitional package for icewm
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides different looks and some desktop-like
 functionality.
 .
 This package only exists to maintain compatibility to system setups that
 relied on the former icewm-lite package. It can be safely removed once the
 system dependencies has been adjusted.

Package: icewm-experimental
Architecture: any
Depends: icewm (= ${binary:Version}),
         icewm-common (= ${binary:Version}),
         ${misc:Depends}
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, and a digital clock.
 .
 This package sometimes provides special IceWm versions with experimental
 features enabled. When the configurations of the packages do not diverge
 it simply enforces an upgrade to the current icewm package.

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 ICONS=$(CURDIR)/debian/icons
 FDO=$(CURDIR)/debian/fdo
 CUSTOM=$(CURDIR)/debian/custom
-cmakeargs = -DDOCDIR=$(DOCDIR) -DHTMLDIR=$(DOCDIR)/html -DICEHELPIDX=/usr/share/doc/icewm-common/html/icewm.html -DCFGDIR=/etc/X11/icewm -DCMAKE_INSTALL_PREFIX=/usr -DVERSION=$(ORIGVERSION) -DCMAKE_VERBOSE_MAKEFILE=ON -DICESOUND=AO -DCONFIG_GDK_PIXBUF_XLIB=on -DCONFIG_XPM=on -DCONFIG_LIBPNG=off -DCONFIG_LIBRSVG=on -DXTERMCMD=x-terminal-emulator
+cmakeargs = -DDOCDIR=$(DOCDIR) -DHTMLDIR=$(DOCDIR)/html -DVERSION=$(ORIGVERSION) -DICEHELPIDX=/usr/share/doc/icewm-common/html/icewm.html -DCFGDIR=/etc/X11/icewm -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_VERBOSE_MAKEFILE=ON -DICESOUND=AO -DCONFIG_IMLIB2=on -DCONFIG_LIBRSVG=on -DCONFIG_XPM=off -DCONFIG_PNG=off -DCONFIG_GDK_PIXBUF_XLIB=off -DXTERMCMD=x-terminal-emulator
 #-DEXTRA_LIBS="-lsupc++" 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
@@ -26,7 +26,7 @@
 endif
 
 %:
-	dh $@ --parallel -Scmake
+	dh $@ -Scmake
 
 # DEBVERSION=$(shell dpkg-parsechangelog -SVersion)
 # that one also works with wheezy
@@ -55,11 +55,17 @@
 override_dh_auto_configure:
 	dh_auto_configure -- $(cmakeargs)
 
+override_dh_autoreconf:
+	true
+
+override_dh_auto_test:
+	true
+
 #override_dh_auto_configure:
 #	$(MAKE) -f debian/rules -j2 config_normal config_lite
 
-#override_dh_auto_build:
-#	dh_auto_build
+override_dh_auto_build:
+	dh_auto_build -- all strtest
 #	cd debian && for x in -lite -experimental ; do cp -lf icewm.postinst icewm$$x.postinst ; cp -lf icewm.prerm icewm$$x.prerm ; done
 
 #override_dh_auto_install:
@@ -89,6 +95,9 @@
 	sed -e 's,^.link.*fonts.googleapis.*,,' -i "$(ICEWM_COMMON)/usr/share/doc/icewm-common/html/"*.html
 	dh_link -A
 
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+
 override_dh_auto_clean:
 	rm -rf $(BDIR)-lite $(BDIR)-normal IceWM-FAQ.txt configure.in
 	# the variants are just symlinks
@@ -115,14 +124,20 @@
 # builds a snapshot of the upstream branch after some plausibility checks
 get-orig-source:
 	! test -e ../icewm_$(ORIGVERSION).orig.tar.xz || (echo Target already exists ; exit 1)
-	lc=`git reflog $(UPSTREAM_BRANCH) | head -n1 | cut -f1 -d" "` && echo "Expected upstream ref: $$lc (on failure run update-debian-mod target)" && grep -m1 ^commit ChangeLog | grep $$lc
+# little canary to prevent forgotten updates - however, not applied for upstream tags
+	if ! test -e .git/refs/tags/$(UPSTREAM_BRANCH) ; then \
+		lc=`git reflog $(UPSTREAM_BRANCH) | head -n1 | cut -f1 -d" "` \
+		&& echo "Expected upstream ref: $$lc (on failure run update-debian-mod target)" \
+		&& grep -m1 ^commit ChangeLog | grep "$$lc" \
+	;fi
 	git tag $(ORIGTAG) $(UPSTREAM_BRANCH)
 	git archive $(ORIGTAG) --prefix icewm-$(ORIGVERSION)/ | xz -9 > ../icewm_$(ORIGVERSION).orig.tar.xz
 	test -d ../tarballs && ln ../icewm_$(ORIGVERSION).orig.tar.xz ../tarballs || true
-	pristine-tar commit ../icewm_$(ORIGVERSION).orig.tar.xz $(UPSTREAM_BRANCH)
+	pristine-tar commit ../icewm_$(ORIGVERSION).orig.tar.xz $(ORIGTAG)
 
 update-debian-mod:
 	grep debian .git/HEAD
-	set -x && git log $$(git log $(UPSTREAM_BRANCH) ChangeLog | head -n1  | cut -c 8- )..$(UPSTREAM_BRANCH) --stat=76 -M -C |fmt -sct -w80 > ChangeLog
-	git show $(UPSTREAM_BRANCH):ChangeLog >> ChangeLog
+	set -x && (echo -e "# created with git log --stat=76 -M -C -500|fmt -sct -w80\n" ; \
+		  git log $(UPSTREAM_BRANCH) --stat=76 -M -C -500|fmt -sct -w80 \
+		)|head -10000 > ChangeLog
 	git commit ChangeLog -m "Updating ChangeLog for a new Debian snapshot"

## icewm 2.2.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -121,11 +121,6 @@
 CHECK_INCLUDE_FILE_CXX(sys/sched.h HAVE_SYS_SCHED_H "-include /usr/include/sched.h")
 CHECK_INCLUDE_FILE_CXX(sys/sysctl.h HAVE_SYS_SYSCTL_H "-include /usr/include/sys/types.h")
 CHECK_INCLUDE_FILE_CXX(uvm/uvm_param.h HAVE_UVM_UVM_PARAM_H)
-
-CHECK_TYPE_SIZE(char SIZEOF_CHAR)
-CHECK_TYPE_SIZE(long SIZEOF_LONG)
-CHECK_TYPE_SIZE(int SIZEOF_INT)
-CHECK_TYPE_SIZE(short SIZEOF_SHORT)
 
 #########################################################
 # fiting flags to options and available system features #
@@ -337,3 +332,5 @@
             list(APPEND audio_libs ${ao_LIBS})
         endif()
     endif()
+    if("${ICESOUND}" MATCHES "oss")
+        CHECK_INCLUDE_FILE_CXX(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)

=== debian/changelog ===
icewm (2.2.0-1.0antix1) unstable; urgency=medium

  * latest upstream
  * Support modifying all icewm preferences directly via a popup.
  * Allow to reset a key or string option in the preferences menu.
  * Show the preference description when modifying a preference.
  * Give each preference option a meaningful description.
  * Drop support for nonICCCMconfigureRequest winoption.
  * Immediately redraw clock after setting default clock format.
  * Add new clock format %H:%M to clock menu.
  * Fix cmake test target for issue #41.
  * Improve CMake build speed by building libraries.
  * If an application resizes itself partially outside the work area, then move it back inside the work area, if possible, for issue #550.
  * Fix ignoreQuickSwitch winoption for focused windows for issue #552.
  * Support locales in icehelp and icewmhint. 
  * antiX build

 -- anticapitalista <antix@operamail.com>  Sun, 28 Feb 2021 17:28:50 +0200

icewm (2.1.2-1.0antix1) unstable; urgency=medium

  * antiX build 

 -- anticapitalista <antix@operamail.com>  Wed, 10 Feb 2021 15:04:03 +0200

## icewm 2.2.1

=== debian/changelog ===
icewm (2.2.1-1.0antix1) unstable; urgency=medium

  * Fix the CMake build
  * Draw an icon in each message box popup
  * Make input field focus tab-traversable when editing preferences
  * When modifying preferences, only trim input for scalar options
  * Simplify the icewm manpage
  * Taskbar may have a non-zero screen due to XineramaPrimaryScreen
  * Position the move/size-status on the screen of the window
  * above are upstream changes
  * antiX build

 -- anticapitalista <antix@operamail.com>  Wed, 03 Mar 2021 14:29:27 +0200

## icewm 2.3.1

=== debian/changelog ===
icewm (2.3.1-1.0antix1) unstable; urgency=medium

  * upstream bugfixes
  * antiX build

 -- anticapitalista <antix@operamail.com>  Sun, 04 Apr 2021 12:24:37 +0300

icewm (2.3.0-1.0antix1) unstable; urgency=medium

  * upstream bugfix, enhancements
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 01 Apr 2021 18:27:13 +0300

## icewm 2.3.2

=== debian/changelog ===
icewm (2.3.2-1.0antix1) unstable; urgency=medium

  * upstream bugfix release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 15 Apr 2021 14:25:52 +0300

## icewm 2.3.3

=== debian/changelog ===
icewm (2.3.3-1.0antix1) unstable; urgency=medium

  * upstream bugfix release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 29 Apr 2021 17:55:35 +0300

## icewm 2.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
 set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})
 
-enable_testing()
+include(CTest)
 
 set(PROJECT_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/src)
 include_directories(${CMAKE_BINARY_DIR})

=== debian/changelog ===
icewm (2.3.4-1.0antix1) unstable; urgency=medium

  * upstream 2.3.4 release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Fri, 07 May 2021 15:23:31 +0300

## icewm 2.4.0

=== debian/changelog ===
icewm (2.4.0-1.0antix1) unstable; urgency=medium

  * latest upstream 2.4.0 release
  * antiX build 

 -- anticapitalista <antix@operamail.com>  Mon, 07 Jun 2021 14:26:17 +0300

## icewm 2.5.0

=== debian/changelog ===
icewm (2.5.0-1.0antix1) unstable; urgency=medium

  * latest 2.5.0 upstream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Sat, 26 Jun 2021 16:11:37 +0300

## icewm 2.6.0

=== debian/changelog ===
icewm (2.6.0-1.0antix1) unstable; urgency=medium

  * latest 2.6.0 upstream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 08 Jul 2021 22:14:50 +0300

## icewm 2.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,6 @@
 
 set(PROJECT_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/src)
 include_directories(${CMAKE_BINARY_DIR})
-include_directories(${PROJECT_SOURCE_DIR})
 
 IF(NOT DEFINED(CMAKE_INSTALL_PREFIX))
 set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE STRING "Target file space")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -76,6 +76,7 @@
 
 set(LOGEVENTS ${ENABLE_LOGEVENTS})
 SET(CONFIG_DEFAULT_THEME "default/default.theme" CACHE STRING "Name of default theme")
+SET(CONFIG_DEFAULT_BACKGROUND "" CACHE STRING "Default background image or directory")
 SET(CONFIG_UNICODE_SET "" CACHE STRING "Your iconv unicode set in machine endian encoding (e.g. WCHAR_T, UCS-4-INTERNAL, UCS-4LE, UCS-4BE)")
 # turn off when empty, see config.h template for details
 IF("" STREQUAL "${CONFIG_UNICODE_SET}")
@@ -333,4 +334,3 @@
         endif()
     endif()
     if("${ICESOUND}" MATCHES "oss")
-        CHECK_INCLUDE_FILE_CXX(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)

=== debian/changelog ===
icewm (2.7.0-1.0antix1) unstable; urgency=medium

  * latest 2.7.0 upstream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Fri, 06 Aug 2021 16:19:08 +0300
